from typing import Any, Dict, List, Type, TypeVar

import attr

T = TypeVar("T", bound="ComponentsschemasJiraExpressionForAnalysisContextVariables")


@attr.s(auto_attribs=True)
class ComponentsschemasJiraExpressionForAnalysisContextVariables:
    """ Context variables and their types. The type checker assumes that [common context variables](https://developer.atlassian.com/cloud/jira/platform/jira-expressions/#context-variables), such as `issue` or `project`, are available in context and sets their type. Use this property to override the default types or provide details of new variables. """

    additional_properties: Dict[str, str] = attr.ib(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update({})

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        componentsschemas_jira_expression_for_analysis_context_variables = cls()

        componentsschemas_jira_expression_for_analysis_context_variables.additional_properties = d
        return componentsschemas_jira_expression_for_analysis_context_variables

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> str:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: str) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
